package at.jku.students.map;

import at.jku.ssw.map.Map;
import at.jku.ssw.util.Company;
import at.jku.ssw.util.Out;

class HashMapMain {

	static final boolean DEBUG_OUTPUT = false;

	public static void main(String[] args) {
		test1(new HashMapSeparateChaining(500));
		test2(new HashMapSeparateChaining(500));
		test3(new HashMapSeparateChaining(500));
		if (DEBUG_OUTPUT) {
			test4();
		}
		test5(new HashMapSeparateChaining(500));
		Out.println();
		Out.println("QUADRATIC");
		Out.println();
		test1(new HashMapQuadraticProbing(500));
		test2(new HashMapQuadraticProbing(500));
		test3(new HashMapQuadraticProbing(500));
		if (DEBUG_OUTPUT) {
			test4();
		}
		test5(new HashMapQuadraticProbing(500));

		Out.println();
		Out.println("LINEAR");
		Out.println();
		test1(new HashMapLinearProbing(500));
		test2(new HashMapLinearProbing(500));
		test3(new HashMapLinearProbing(500));
		if (DEBUG_OUTPUT) {
			test4();
		}
		test5(new HashMapLinearProbing(500));
	}

	static void test1(Map m) {
		Out.println("\n*** Test 1 *** \n");

		m.put("JKU", "0732/2468");
		m.put("Buergerservice Linz", "0732/7070");
		m.put("Linz AG", "0732/3400-4000");
		m.put("OEBB", "05-1717");

		m.put("JKU", "0732/2468-1111");
		m.put("JKU", "0732/2468-2222");
		m.put("JKU", "0732/2468-3333");
		m.put("JKU", "0732/2468-4444");
		Out.println("m.get(\"JKU\")=" + m.get("JKU")); // "0732/2468-4444"

		Out.println("m.containsKey(\"Linz AG\")=" + m.containsKey("Linz AG")); // true
		Out.println("m.containsKey(\"Energie AG\")=" + m.containsKey("Energie AG")); // false

		m.put("Energie AG", null);
		Out.println("m.containsKey(\"Energie AG\")=" + m.containsKey("Energie AG")); // true
		Out.println("m.get(\"Energie AG\")=" + m.get("Energie AG")); // null

		Out.println("m.remove(\"JKU\")=" + m.remove("JKU"));
		Out.println("m.containsKey(\"JKU\")=" + m.containsKey("JKU")); // false

	}

	static void test2(Map m) {
		Out.println("\n*** Test 2 *** \n");

		m.put("JKU", "0732/2468");
		m.put("Buergerservice Linz", "0732/7070");
		m.put("Linz AG", "0732/3400-4000");
		m.put("OEBB", "05-1717");

		Out.println("m.remove(\"Linz AG\")=" + m.remove("Linz AG"));

		m.put("Energie AG", "0800-81 8000");
		m.put("Sparkasse", "50-100-10100");

		Out.println("m.get(\"OEBB\")=" + m.get("OEBB")); // "05-1717"

	}

	static void test3(Map m) {
		Out.println("\n*** Test 3 *** \n");
		Company[] companies = TOP500;
		for (Company c : companies) {
			m.put(c.name, c);
		}

		String[] names = { "Volkswagen", "Total", "Daimler", "Gazprom", "Panasonic", "Sony", "BMW", "Apple",
				"Coca-Cola", "Landesbank Baden-Wuerttemberg", "Woolworths", "Royal Ahold", "Bertelsmann", "Henkel" };

		for (int i = 0; i < names.length; i++) {
			String name = names[i];
			Company c = (Company) m.get(name);
			Out.println(c.toString());
		}
	}

	static void test4() {
		Out.println("\n*** Test 4 *** \n");
		Company[] companies = TOP500;
		for (int i = 0; i < companies.length; i++) {
			Company c = companies[i];
			System.out.println(String.format("%s: %d", c.name, c.name.hashCode()));
		}
	}

	static void test5(Map m) {
		String[] keys = new String[26];
		for (char c = 'A'; c <= 'Z'; c++) {
			keys[c - 'A'] = Character.toString(c);
			m.put(keys[c - 'A'], null);
		}

		for (char c = 'A'; c <= 'Z'; c++) {
			Out.println("m.containsKey(\"" + keys[c - 'A'] + "\")=" + m.containsKey(keys[c - 'A']));
		}
	}

	private static Company[] TOP500 = { new Company(1, "Wal-Mart Stores", 408214, 14335), //
			new Company(2, "Royal Dutch Shell", 285129, 12518), //
			new Company(3, "Exxon Mobil", 284650, 19280), //
			new Company(4, "BP", 246138, 16578), //
			new Company(5, "Toyota Motor", 204106, 2256), //
			new Company(6, "Japan Post Holdings", 202196, 4849), //
			new Company(7, "Sinopec", 187518, 5756), //
			new Company(8, "State Grid", 184496, -343), //
			new Company(9, "AXA", 175257, 5012), //
			new Company(10, "China National Petroleum", 165496, 10272), //
			new Company(11, "Chevron", 163527, 10483), //
			new Company(12, "ING Group", 163204, -1300), //
			new Company(13, "General Electric", 156779, 11025), //
			new Company(14, "Total", 155887, 11741), //
			new Company(15, "Bank of America Corp.", 150450, 6276), //
			new Company(16, "Volkswagen", 146205, 1334), //
			new Company(17, "ConocoPhillips", 139515, 4858), //
			new Company(18, "BNP Paribas", 130708, 8106), //
			new Company(19, "Assicurazioni Generali", 126012, 1820), //
			new Company(20, "Allianz", 125999, 5973), //
			new Company(21, "AT&T", 123018, 12535), //
			new Company(22, "Carrefour", 121452, 454), //
			new Company(23, "Ford Motor", 118308, 2717), //
			new Company(24, "ENI", 117235, 6070), //
			new Company(25, "J.P. Morgan Chase & Co.", 115632, 11728), //
			new Company(26, "Hewlett-Packard", 114552, 7660), //
			new Company(27, "E.ON", 113849, 11670), //
			new Company(28, "Berkshire Hathaway", 112493, 8055), //
			new Company(29, "GDF Suez", 111069, 6223), //
			new Company(30, "Daimler", 109700, -3670), //
			new Company(31, "Nippon Telegraph & Telephone", 109656, 5302), //
			new Company(32, "Samsung Electronics", 108927, 7562), //
			new Company(33, "Citigroup", 108785, -1606), //
			new Company(34, "McKesson", 108702, 1263), //
			new Company(35, "Verizon Communications", 107808, 3651), //
			new Company(36, "Credit Agricole", 106538, 1564), //
			new Company(37, "Banco Santander", 106345, 12430), //
			new Company(38, "General Motors", 104589, 0), //
			new Company(39, "HSBC Holdings", 103736, 5834), //
			new Company(40, "Siemens", 103605, 3097), //
			new Company(41, "American International Group", 103189, -10949), //
			new Company(42, "Lloyds Banking Group", 102967, 4409), //
			new Company(43, "Cardinal Health", 99613, 1152), //
			new Company(44, "Nestle", 99114, 9604), //
			new Company(45, "CVS Caremark", 98729, 3696), //
			new Company(46, "Wells Fargo", 98636, 12275), //
			new Company(47, "Hitachi", 96593, -1152), //
			new Company(48, "International Business Machines", 95758, 13425), //
			new Company(49, "Dexia Group", 95144, 1404), //
			new Company(50, "Gazprom", 94472, 24556), //
			new Company(51, "Honda Motor", 92400, 2891), //
			new Company(52, "electricite de France", 92204, 5428), //
			new Company(53, "Aviva", 92140, 1692), //
			new Company(54, "Petrobras", 91869, 15504), //
			new Company(55, "Royal Bank of Scotland", 91767, -4167), //
			new Company(56, "PDVSA", 91182, 1608), //
			new Company(57, "Metro", 91152, 532), //
			new Company(58, "Tesco", 90234, 3690), //
			new Company(59, "Deutsche Telekom", 89794, 491), //
			new Company(60, "Enel", 89329, 7499), //
			new Company(61, "UnitedHealth Group", 87138, 3822), //
			new Company(62, "Societe Generale", 84157, 942), //
			new Company(63, "Nissan Motor", 80963, 456), //
			new Company(64, "Pemex", 80722, -7011), //
			new Company(65, "Panasonic", 79893, -1114), //
			new Company(66, "Procter & Gamble", 79697, 13436), //
			new Company(67, "LG", 78892, 1206), //
			new Company(68, "Telefonica", 78853, 10808), //
			new Company(69, "Sony", 77696, -439), //
			new Company(70, "Kroger", 76733, 70), //
			new Company(71, "Groupe BPCE", 76464, 746), //
			new Company(72, "Prudential", 75010, 1054), //
			new Company(73, "Munich Re Group", 74764, 3504), //
			new Company(74, "Statoil", 74000, 2912), //
			new Company(75, "Nippon Life Insurance", 72051, 2624), //
			new Company(76, "AmerisourceBergen", 71789, 503), //
			new Company(77, "China Mobile Communications", 71749, 11656), //
			new Company(78, "Hyundai Motor", 71678, 2330), //
			new Company(79, "Costco Wholesale", 71422, 1086), //
			new Company(80, "Vodafone", 70899, 13782), //
			new Company(81, "BASF", 70461, 1960), //
			new Company(82, "BMW", 70444, 284), //
			new Company(83, "Zurich Financial Services", 70272, 3215), //
			new Company(84, "Valero Energy", 70035, -1982), //
			new Company(85, "Fiat", 69639, -1165), //
			new Company(86, "Deutsche Post", 69427, 895), //
			new Company(87, "Industrial & Commercial Bank of China", 69295, 18832), //
			new Company(88, "Archer Daniels Midland", 69207, 1707), //
			new Company(89, "Toshiba", 68731, -213), //
			new Company(90, "Legal & General Group", 68290, 1346), //
			new Company(91, "Boeing", 68281, 1312), //
			new Company(92, "U.S. Postal Service", 68090, -3794), //
			new Company(93, "Lukoil", 68025, 7011), //
			new Company(94, "Peugeot", 67297, -1614), //
			new Company(95, "CNP Assurances", 66556, 1396), //
			new Company(96, "Barclays", 66533, 14648), //
			new Company(97, "Home Depot", 66176, 2661), //
			new Company(98, "Target", 65357, 2488), //
			new Company(99, "ArcelorMittal", 65110, 118), //
			new Company(100, "WellPoint", 65028, 4746), //
			new Company(101, "RWE", 64795, 4964), //
			new Company(102, "UniCredit Group", 64709, 2366), //
			new Company(103, "Aegon", 64506, 284), //
			new Company(104, "SK Holdings", 64396, 211), //
			new Company(105, "France Telecom", 63860, 4166), //
			new Company(106, "Walgreen", 63335, 2006), //
			new Company(107, "Petronas", 62577, 11649), //
			new Company(108, "Johnson & Johnson", 61897, 12266), //
			new Company(109, "State Farm Insurance Cos.", 61480, 767), //
			new Company(110, "Medco Health Solutions", 59804, 1280), //
			new Company(111, "EADS", 59520, -1060), //
			new Company(112, "Hon Hai Precision Industry", 59324, 2292), //
			new Company(113, "Deutsche Bank", 58998, 6912), //
			new Company(114, "Repsol YPF", 58571, 2167), //
			new Company(115, "Microsoft", 58437, 14569), //
			new Company(116, "China Construction Bank", 58361, 15628), //
			new Company(117, "Itausa-Investimentos Itau", 57859, 1966), //
			new Company(118, "China Life Insurance", 57019, 3125), //
			new Company(119, "Dai-ichi Life Insurance", 57018, 600), //
			new Company(120, "Nokia", 56966, 1238), //
			new Company(121, "Unilever", 55352, 4684), //
			new Company(122, "Groupe Auchan", 55141, 919), //
			new Company(123, "ThyssenKrupp", 54816, -2510), //
			new Company(124, "Seven & I Holdings", 54701, 480), //
			new Company(125, "Indian Oil", 54288, 2258), //
			new Company(126, "Mitsubishi UFJ Financial Group", 54285, 4187), //
			new Company(127, "AEON", 54092, 333), //
			new Company(128, "Tokyo Electric Power", 54026, 1441), //
			new Company(129, "Robert Bosch", 53060, -1751), //
			new Company(130, "United Technologies", 52920, 3829), //
			new Company(131, "Dell", 52902, 1433), //
			new Company(132, "Saint-Gobain", 52521, 281), //
			new Company(133, "China Railway Construction", 52044, 960), //
			new Company(134, "Goldman Sachs Group", 51673, 13385), //
			new Company(135, "Banco Bradesco", 51608, 4007), //
			new Company(136, "JX Holdings", 51405, 466), //
			new Company(137, "China Railway Group", 50704, 1008), //
			new Company(138, "Fujitsu", 50399, 1002), //
			new Company(139, "BHP Billiton", 50211, 5877), //
			new Company(140, "Pfizer", 50009, 8635), //
			new Company(141, "Agricultural Bank of China", 49742, 9514), //
			new Company(142, "Best Buy", 49694, 1317), //
			new Company(143, "Bank of China", 49682, 11868), //
			new Company(144, "Marathon Oil", 49403, 1463), //
			new Company(145, "Veolia Environnement", 49142, 812), //
			new Company(146, "Mitsubishi", 48913, 2942), //
			new Company(147, "A.P. Moeller-Marsk Group", 48824, -1312), //
			new Company(148, "Banco do Brasil", 48122, 5075), //
			new Company(149, "Banco Bilbao Vizcaya Argentaria", 48074, 5852), //
			new Company(150, "Credit Suisse", 47658, 6193), //
			new Company(151, "Intesa Sanpaolo", 47282, 3899), //
			new Company(152, "Lowe's", 47220, 1783), //
			new Company(153, "Roche Group", 47109, 7169), //
			new Company(154, "Renault", 46858, -4344), //
			new Company(155, "PTT", 46220, 1735), //
			new Company(156, "China Southern Power Grid", 45735, 250), //
			new Company(157, "United Parcel Service", 45297, 2152), //
			new Company(158, "Meiji Yasuda Life Insurance", 45262, 1538), //
			new Company(159, "Lockheed Martin", 45189, 3024), //
			new Company(160, "Novartis", 45103, 8400), //
			new Company(161, "Dow Chemical", 44945, 648), //
			new Company(162, "Vinci", 44378, 2218), //
			new Company(163, "GlaxoSmithKline", 44240, 8626), //
			new Company(164, "Mitsui", 44120, 1612), //
			new Company(165, "Sears Holdings", 44043, 235), //
			new Company(166, "Sumitomo Life Insurance", 43780, 1205), //
			new Company(167, "International Assets Holding", 43604, 28), //
			new Company(168, "Bouygues", 43579, 1833), //
			new Company(169, "Sanofi-Aventis", 43405, 7318), //
			new Company(170, "Bayer", 43322, 1889), //
			new Company(171, "PepsiCo", 43232, 5946), //
			new Company(172, "Bunge", 41926, 361), //
			new Company(173, "Rio Tinto Group", 41825, 4872), //
			new Company(174, "MetLife", 41098, -2246), //
			new Company(175, "Reliance Industries", 41085, 3422), //
			new Company(176, "Safeway", 40851, -1098), //
			new Company(177, "Deutsche Bahn", 40774, 1141), //
			new Company(178, "Supervalu", 40597, 393), //
			new Company(179, "Kraft Foods", 40386, 3021), //
			new Company(180, "Fonciere Euris", 40385, 58), //
			new Company(181, "Telecom Italia", 39764, 2198), //
			new Company(182, "Dongfeng Motor", 39402, 720), //
			new Company(183, "UBS", 39356, -2520), //
			new Company(184, "Royal Ahold", 38814, 1243), //
			new Company(185, "NEC", 38591, 123), //
			new Company(186, "Tokio Marine Holdings", 38458, 1383), //
			new Company(187, "China State Construction Engineering", 38117, 839), //
			new Company(188, "Centrica", 37927, 1316), //
			new Company(189, "Vivendi", 37712, 1154), //
			new Company(190, "Freddie Mac", 37614, -21553), //
			new Company(191, "Nippon Steel", 37563, -124), //
			new Company(192, "Wesfarmers", 37466, 1128), //
			new Company(193, "KDDI", 37073, 2292), //
			new Company(194, "Sysco", 36853, 1056), //
			new Company(195, "Itochu", 36798, 1380), //
			new Company(196, "Anheuser-Busch InBev", 36758, 4613), //
			new Company(197, "Apple", 36537, 5704), //
			new Company(198, "Woolworths", 36523, 1349), //
			new Company(199, "Walt Disney", 36149, 3307), //
			new Company(200, "Cisco Systems", 36117, 6134), //
			new Company(201, "Mitsubishi Electric", 36116, 305), //
			new Company(202, "Comcast", 35756, 3638), //
			new Company(203, "Sinochem Group", 35577, 659), //
			new Company(204, "China Telecommunications", 35557, 581), //
			new Company(205, "FedEx", 35497, 98), //
			new Company(206, "Marubeni", 35326, 1026), //
			new Company(207, "Northrop Grumman", 35291, 1686), //
			new Company(208, "Manulife Financial", 35144, 1228), //
			new Company(209, "Intel", 35127, 4369), //
			new Company(210, "Aetna", 34764, 1276), //
			new Company(211, "Rosneft Oil", 34695, 6514), //
			new Company(212, "DZ Bank", 34633, 186), //
			new Company(213, "Commerzbank", 34611, -6306), //
			new Company(214, "SNCF", 34585, -1362), //
			new Company(215, "Scottish & Southern Energy", 34357, 1969), //
			new Company(216, "Canon", 34292, 1407), //
			new Company(217, "Iberdrola", 34136, 3926), //
			new Company(218, "Sumitomo Mitsui Financial Group", 34104, 2925), //
			new Company(219, "Franz Haniel", 34087, 8), //
			new Company(220, "Old Mutual", 34072, -530), //
			new Company(221, "New York Life Insurance", 34014, 683), //
			new Company(222, "BT Group", 33860, 1639), //
			new Company(223, "Shanghai Automotive", 33629, 1070), //
			new Company(224, "China Communications Construction", 33465, 704), //
			new Company(225, "Rabobank", 33396, 3029), //
			new Company(226, "AstraZeneca", 32804, 7521), //
			new Company(227, "Prudential Financial", 32688, 3124), //
			new Company(228, "Royal Bank of Canada", 32610, 3298), //
			new Company(229, "Caterpillar", 32396, 895), //
			new Company(230, "Sprint Nextel", 32260, -2436), //
			new Company(231, "Royal Philips Electronics", 32232, 570), //
			new Company(232, "Denso", 32060, 791), //
			new Company(233, "Allstate", 32013, 854), //
			new Company(234, "General Dynamics", 31981, 2394), //
			new Company(235, "Danske Bank Group", 31851, 322), //
			new Company(236, "J. Sainsbury", 31828, 933), //
			new Company(237, "ABB", 31797, 2901), //
			new Company(238, "BAE Systems", 31773, -104), //
			new Company(239, "Mitsubishi Heavy Industries", 31674, 152), //
			new Company(240, "Morgan Stanley", 31515, 1346), //
			new Company(241, "Nippon Mining Holdings", 31512, 321), //
			new Company(242, "Noble Group", 31183, 556), //
			new Company(243, "Liberty Mutual Insurance Group", 31094, 1023), //
			new Company(244, "Sumitomo", 31063, 1672), //
			new Company(245, "Coca-Cola", 30990, 6824), //
			new Company(246, "Lufthansa Group", 30972, -156), //
			new Company(247, "Humana", 30960, 1040), //
			new Company(248, "Honeywell International", 30908, 2153), //
			new Company(249, "LyondellBasell Industries", 30829, -2865), //
			new Company(250, "Abbott Laboratories", 30765, 5746), //
			new Company(251, "Swiss Reinsurance", 30745, 466), //
			new Company(252, "China National Offshore Oil", 30680, 3634), //
			new Company(253, "JFE Holdings", 30634, 492), //
			new Company(254, "Citic Group", 30605, 2766), //
			new Company(255, "News Corp.", 30423, -3378), //
			new Company(256, "Sberbank", 30394, 768), //
			new Company(257, "Mizuho Financial Group", 30346, 2578), //
			new Company(258, "China FAW Group", 30237, 1382), //
			new Company(259, "Landesbank Baden-Wuerttemberg", 30062, -2061), //
			new Company(260, "HCA", 30052, 1054), //
			new Company(261, "Edeka Zentrale", 29976, 262), //
			new Company(262, "Alliance Boots", 29848, 969), //
			new Company(263, "Softbank", 29762, 1042), //
			new Company(264, "Sharp", 29682, 47), //
			new Company(265, "Air France-KLM Group", 29644, -2201), //
			new Company(266, "Sunoco", 29630, -329), //
			new Company(267, "Hess", 29569, 740), //
			new Company(268, "Ingram Micro", 29515, 202), //
			new Company(269, "America Movil", 29233, 5696), //
			new Company(270, "Fannie Mae", 29065, -71969), //
			new Company(271, "Power Corp. of Canada", 29050, 598), //
			new Company(272, "POSCO", 28883, 2522), //
			new Company(273, "Koc Holding", 28845, 920), //
			new Company(274, "Time Warner", 28842, 2468), //
			new Company(275, "China South Industries Group", 28757, 274), //
			new Company(276, "Baosteel Group", 28591, 1448), //
			new Company(277, "Idemitsu Kosan", 28560, 64), //
			new Company(278, "Volvo", 28551, -1924), //
			new Company(279, "La Poste", 28532, 738), //
			new Company(280, "Johnson Controls", 28497, -338), //
			new Company(281, "Cathay Life Insurance", 28315, 81), //
			new Company(282, "State Bank of India", 28213, 2473), //
			new Company(283, "Kansai Electric Power", 28074, 1370), //
			new Company(284, "Delta Air Lines", 28063, -1237), //
			new Company(285, "George Weston", 28009, 907), //
			new Company(286, "Poste Italiane", 27935, 1256), //
			new Company(287, "Continental", 27932, -2292), //
			new Company(288, "Standard Life", 27803, 332), //
			new Company(289, "Bridgestone", 27750, 11), //
			new Company(290, "Alstom", 27739, 1718), //
			new Company(291, "Delhaize Group", 27732, 714), //
			new Company(292, "East Japan Railway", 27720, 1295), //
			new Company(293, "Sabic", 27481, 2420), //
			new Company(294, "Merck", 27428, 12901), //
			new Company(295, "Medipal Holdings", 27421, 21), //
			new Company(296, "DuPont", 27328, 1755), //
			new Company(297, "Tyson Foods", 27165, -537), //
			new Company(298, "Commonwealth Bank of Australia", 27162, 3471), //
			new Company(299, "Mitsubishi Chemical Holdings", 27088, 138), //
			new Company(300, "GS Holdings", 27066, 383), //
			new Company(301, "L.M. Ericsson", 26997, 480), //
			new Company(302, "Hutchison Whampoa", 26938, 1828), //
			new Company(303, "Vattenfall", 26857, 1686), //
			new Company(304, "American Express", 26730, 2130), //
			new Company(305, "National Australia Bank", 26708, 1879), //
			new Company(306, "Korea Electric Power", 26640, -76), //
			new Company(307, "Bharat Petroleum", 26596, 344), //
			new Company(308, "Suzuki Motor", 26592, 311), //
			new Company(309, "PPR", 26534, 1368), //
			new Company(310, "Finmeccanica", 26335, 909), //
			new Company(311, "TIAA-CREF", 26278, -459), //
			new Company(312, "COFCO", 26098, 629), //
			new Company(313, "China Huaneng Group", 26019, 39), //
			new Company(314, "Hebei Iron & Steel Group", 25924, 135), //
			new Company(315, "China Metallurgical Group", 25868, 412), //
			new Company(316, "Samsung Life Insurance", 25805, 750), //
			new Company(317, "CHS", 25730, 381), //
			new Company(318, "TNK-BP Holding", 25696, 5175), //
			new Company(319, "Rite Aid", 25669, -507), //
			new Company(320, "Westpac Banking", 25623, 2501), //
			new Company(321, "KFW Bankengruppe", 25582, 1566), //
			new Company(322, "Hochtief", 25563, 271), //
			new Company(323, "Groupama", 25539, 917), //
			new Company(324, "Cepsa", 25526, 521), //
			new Company(325, "Enterprise GP Holdings", 25511, 204), //
			new Company(326, "GasTerra", 25449, 50), //
			new Company(327, "Quanta Computer", 25429, 676), //
			new Company(328, "Massachusetts Mutual Life Insurance", 25424, -115), //
			new Company(329, "T&D Holdings", 25299, 262), //
			new Company(330, "Aviation Industry Corp. of China", 25189, 767), //
			new Company(331, "Philip Morris International", 25035, 6342), //
			new Company(332, "China Minmetals", 24956, 299), //
			new Company(333, "OMV Group", 24904, 795), //
			new Company(334, "Raytheon", 24881, 1935), //
			new Company(335, "Express Scripts", 24749, 828), //
			new Company(336, "Hartford Financial Services", 24701, -887), //
			new Company(337, "Travelers Cos.", 24680, 3622), //
			new Company(338, "Christian Dior", 24665, 966), //
			new Company(339, "Publix Super Markets", 24515, 1161), //
			new Company(340, "Amazon.com", 24509, 902), //
			new Company(341, "Wolseley", 24461, -1842), //
			new Company(342, "L'Oreal", 24286, 2491), //
			new Company(343, "Staples", 24276, 739), //
			new Company(344, "William Morrison Supermarkets", 24263, 942), //
			new Company(345, "Bayerische Landesbank", 24255, -3640), //
			new Company(346, "ACS", 24245, 2712), //
			new Company(347, "Sun Life Financial", 24160, 537), //
			new Company(348, "China North Industries Group", 24150, 456), //
			new Company(349, "CRH", 24148, 823), //
			new Company(350, "Flextronics International", 24111, 19), //
			new Company(351, "Chubu Electric Power", 24110, 1169), //
			new Company(352, "Sinosteel", 24014, 42), //
			new Company(353, "Wilmar International", 23885, 1882), //
			new Company(354, "Hindustan Petroleum", 23881, 311), //
			new Company(355, "Google", 23651, 6520), //
			new Company(356, "Shenhua Group", 23605, 3278), //
			new Company(357, "Mapfre Group", 23526, 1288), //
			new Company(358, "Hanwha", 23521, 439), //
			new Company(359, "Fujifilm Holdings", 23497, -414), //
			new Company(360, "Macy's", 23489, 350), //
			new Company(361, "KBC Group", 23376, -3428), //
			new Company(362, "International Paper", 23366, 663), //
			new Company(363, "Vale", 23311, 5349), //
			new Company(364, "Mazda Motor", 23306, -70), //
			new Company(365, "Ageas", 23254, 1657), //
			new Company(366, "Oracle", 23252, 5593), //
			new Company(367, "Norddeutsche Landesbank", 23201, -211), //
			new Company(368, "China United Network Communications", 23183, 459), //
			new Company(369, "Accenture", 23171, 1590), //
			new Company(370, "3M", 23123, 3193), //
			new Company(371, "People's Insurance Co. of China", 23116, 150), //
			new Company(372, "Deere", 23112, 874), //
			new Company(373, "Cosmo Oil", 23068, -116), //
			new Company(374, "Migros", 22976, 908), //
			new Company(375, "Hyundai Heavy Industries", 22926, 1678), //
			new Company(376, "Maruhan", 22843, 295), //
			new Company(377, "Imperial Tobacco Group", 22760, 1023), //
			new Company(378, "McDonald's", 22745, 4551), //
			new Company(379, "Xstrata", 22732, 661), //
			new Company(380, "Schlumberger", 22702, 3134), //
			new Company(381, "Heraeus Holding", 22545, 162), //
			new Company(382, "Jardine Matheson", 22501, 1604), //
			new Company(383, "Ping An Insurance", 22374, 2032), //
			new Company(384, "National Grid", 22331, 2210), //
			new Company(385, "Suncor Energy", 22327, 1004), //
			new Company(386, "Alfresa Holdings", 22179, 113), //
			new Company(387, "British American Tobacco", 22157, 4231), //
			new Company(388, "Aisin Seiki", 22127, 179), //
			new Company(389, "Tech Data", 22100, 180), //
			new Company(390, "Lafarge", 22078, 1023), //
			new Company(391, "Motorola", 22063, -51), //
			new Company(392, "Bertelsmann", 22036, -114), //
			new Company(393, "Fluor", 21990, 685), //
			new Company(394, "Schneider Electric", 21952, 1184), //
			new Company(395, "China Resources National", 21902, 995), //
			new Company(396, "Eli Lilly", 21836, 4329), //
			new Company(397, "Huawei Technologies", 21821, 2672), //
			new Company(398, "PKN Orlen Group", 21797, 420), //
			new Company(399, "Australia & New Zealand Banking", 21778, 2136), //
			new Company(400, "Onex", 21758, 98), //
			new Company(401, "Toronto-Dominion Bank", 21733, 2667), //
			new Company(402, "Ricoh", 21716, 300), //
			new Company(403, "Yamada Denki", 21714, 603), //
			new Company(404, "Coca-Cola Enterprises", 21645, 731), //
			new Company(405, "Bristol-Myers Squibb", 21634, 10612), //
			new Company(406, "Energie Baden-Wuerttemberg", 21634, 1068), //
			new Company(407, "Showa Shell Sekiyu", 21612, -616), //
			new Company(408, "Northwestern Mutual", 21603, 321), //
			new Company(409, "Nordea Bank", 21600, 3216), //
			new Company(410, "Tata Steel", 21582, -424), //
			new Company(411, "DIRECTV", 21565, 942), //
			new Company(412, "China Datang Group", 21460, -282), //
			new Company(413, "Oil & Natural Gas", 21448, 4090), //
			new Company(414, "Bank of Nova Scotia", 21428, 3032), //
			new Company(415, "Jiangsu Shagang Group", 21419, 377), //
			new Company(416, "Japan Tobacco", 21335, 1491), //
			new Company(417, "MS & AD Insurance Group Holdings", 21139, 405), //
			new Company(418, "Alcatel-Lucent", 21068, -728), //
			new Company(419, "Standard Chartered Group", 20941, 3380), //
			new Company(420, "Emerson Electric", 20915, 1724), //
			new Company(421, "Anglo American", 20858, 2425), //
			new Company(422, "Danone", 20824, 1892), //
			new Company(423, "Nationwide", 20751, 716), //
			new Company(424, "Compass Group", 20747, 904), //
			new Company(425, "Gas Natural Fenosa", 20681, 1661), //
			new Company(426, "Michelin", 20581, 147), //
			new Company(427, "Adecco", 20567, 11), //
			new Company(428, "Wuhan Iron & Steel", 20543, 174), //
			new Company(429, "Kirin Holdings", 20503, 525), //
			new Company(430, "Heineken Holding", 20491, 709), //
			new Company(431, "Compal Electronics", 20448, 582), //
			new Company(432, "Premafin Finanziaria", 20424, -187), //
			new Company(433, "TJX", 20288, 1214), //
			new Company(434, "CPC", 20253, 1140), //
			new Company(435, "AMR", 19917, -1468), //
			new Company(436, "Aluminum Corp. of China", 19851, -622), //
			new Company(437, "Sodexo", 19818, 530), //
			new Company(438, "Sumitomo Electric Industries", 19778, 309), //
			new Company(439, "Fresenius", 19687, 687), //
			new Company(440, "Bank of Communications", 19568, 4409), //
			new Company(441, "AREVA", 19548, 767), //
			new Company(442, "Tata Motors", 19501, 542), //
			new Company(443, "U.S. Bancorp", 19490, 2205), //
			new Company(444, "Co-operative Group", 19477, 627), //
			new Company(445, "NKSJ Holdings", 19470, 424), //
			new Company(446, "Holcim", 19462, 1355), //
			new Company(447, "GMAC", 19403, -10298), //
			new Company(448, "Bombardier", 19366, 698), //
			new Company(449, "TUI", 19344, 463), //
			new Company(450, "Akzo Nobel", 19311, 396), //
			new Company(451, "PNC Financial Services Group", 19231, 2447), //
			new Company(452, "Formosa Petrochemical", 19204, 1187), //
			new Company(453, "Nike", 19176, 1487), //
			new Company(454, "Murphy Oil", 19138, 838), //
			new Company(455, "Kimberly-Clark", 19115, 1884), //
			new Company(456, "Eiffage", 18958, 264), //
			new Company(457, "Henkel", 18866, 837), //
			new Company(458, "Telstra", 18824, 2993), //
			new Company(459, "Royal KPN", 18777, 3027), //
			new Company(460, "Sistema", 18750, 1643), //
			new Company(461, "Alcoa", 18745, -1151), //
			new Company(462, "Suzuken", 18692, 150), //
			new Company(463, "Boehringer Ingelheim", 18630, 2445), //
			new Company(464, "Plains All American Pipeline", 18520, 579), //
			new Company(465, "Asustek Computer", 18474, 378), //
			new Company(466, "Erste Group Bank", 18468, 1256), //
			new Company(467, "Cigna", 18414, 1302), //
			new Company(468, "Nippon Yusen", 18281, -188), //
			new Company(469, "Aflac", 18254, 1497), //
			new Company(470, "Evonik Industries", 18175, 334), //
			new Company(471, "Ultrapar Holdings", 18064, 233), //
			new Company(472, "Gruppo Mediolanum", 18057, 302), //
			new Company(473, "Kobe Steel", 17997, 68), //
			new Company(474, "Tohoku Electric Power", 17915, 278), //
			new Company(475, "Thales Group", 17905, -280), //
			new Company(476, "Skanska", 17887, 474), //
			new Company(477, "China Guodian", 17871, 32), //
			new Company(478, "Time Warner Cable", 17868, 1070), //
			new Company(479, "Sanyo Electric", 17850, -526), //
			new Company(480, "Fomento de Construcciones", 17652, 427), //
			new Company(481, "Kajima", 17635, 142), //
			new Company(482, "Cie Nationale a Portefeuille", 17571, 412), //
			new Company(483, "United Services Automobile Association", 17558, 3020), //
			new Company(484, "J.C. Penney", 17556, 251), //
			new Company(485, "Sumitomo Chemical", 17458, 159), //
			new Company(486, "Strabag", 17447, 224), //
			new Company(487, "Acer", 17380, 344), //
			new Company(488, "Magna International", 17367, -493), //
			new Company(489, "Daiwa House Industry", 17339, 206), //
			new Company(490, "MAN Group", 17320, -375), //
			new Company(491, "Exelon", 17318, 2707), //
			new Company(492, "Tyco International", 17240, -1798), //
			new Company(493, "Coop", 17238, 396), //
			new Company(494, "Randstad Holding", 17235, 95), //
			new Company(495, "Kohl's", 17178, 991), //
			new Company(496, "JBS", 17161, 64), //
			new Company(497, "Shimizu", 17117, -74), //
			new Company(498, "Whirlpool", 17099, 328), //
			new Company(499, "Suez Environnement", 17091, 560), //
			new Company(500, "Dai Nippon Printing", 17053, 251), //
	};
}
